/*

  Build a tree with the divisors of a number

*/

#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>

#include <string> // C++ string

using namespace std ;

class Node {
  int           number ;
  vector<Node*> childs ;
  
  void free() ;

public:

  Node() : number(1) {    
    cout << "Enter to the contructor of Node\n" ;
  }

  Node( int n ) : number(1) {    
    cout << "Enter to the contructor of Node(" << n << ")\n" ;
    build( n ) ;
  }

  ~Node() ;

  void build( int n ) ;
  void print( ostream &, int level = 0 ) ;
  void to_dag( ostream &, int level = 0 ) ;
  void to_tree( ostream &, int level = 0 ) ;

} ;

void
Node::free() {
  cout << "Enter to the destructor of Node (" << number << ")\n" ;
  for ( vector<Node*>::iterator it = childs.begin() ; it != childs.end() ; ++it )
    delete *it ; // *it is a pointer to the corresponding child Node
                 // call the destroyer for the Node *it
  childs.clear() ;
}

Node::~Node() {
  free() ;
}

void
Node::build( int n ) {
  //cout << "Enter build for number " << n << "\n" ;
  if ( number != 1 ) free() ;
  number = n ;
  // search for the divisors
  for ( int i = 2 ; i < n ; ++i ) {
    if ( (n % i) == 0 ) { // found a divisor
      //cout << "found divisor: " << i << " for number " << number << '\n' ;
      Node * pChild = new Node(i) ; // allocate the new divisor `i`
      //pChild->build(i) ; // compute the divisor of i
      childs.push_back(pChild) ; // add to the list of child od `number`
    }
  }
  //cout << "Exit build for number " << n << "\n" ;
}

void
Node::print( ostream & stream, int level ) {
  stream << std::string(level*4, ' ') ;
  stream << number << '\n' ;
  for ( int i = 0 ; i < childs.size() ; ++i )
    childs[i]->print( stream, level + 1 ) ;
}

void
Node::to_dag( ostream & stream, int level ) {
  if ( level == 0 ) stream << "digraph divisor_of_" << number << " {\n" ;
  for ( int i = 0 ; i < childs.size() ; ++i ) {
    stream << "  " << number << " -> " << childs[i]->number << ";\n" ;
    childs[i]->to_dag( stream, level + 1 ) ;
  }
  if ( level == 0 ) stream << "}\n" ;
}


int
main() {
  Node n(12) ;
  n.to_dag(cout) ;

  //n.build(234) ;
  //n.to_dag(cout) ;

  return 0 ;
}

